#pragma once

#include <time.h>
#include "OSUInventor.h"
#include "raytracer.h"

namespace WinRay
{
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;

	/// <summary> 
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the 
	///          'Resource File Name' property for the managed resource compiler tool 
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public __gc class Form1 : public System::Windows::Forms::Form
	{	
	public:
		Form1(void)
		{
			InitializeComponent();
			drawing = new Bitmap(2048, 2048);
			frame = -1;
		}
  
	protected:
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
	private: System::Windows::Forms::OpenFileDialog *  openFileDialog1;
	private: System::Windows::Forms::SaveFileDialog *  saveFileDialog1;
	private: System::Windows::Forms::Button *  button1;
	private: Bitmap *drawing;
	private: Scene *_scene;
	private: Camera *_camera;
	private: int sl, sl_last;
	private: int frame;
	private: float radius, y;
	private: bool quick;
	private: System::Windows::Forms::Timer *  timer1;

	private: System::Windows::Forms::NumericUpDown *  resUpDown;
	private: System::Windows::Forms::CheckBox *  textureCheck;
	private: System::Windows::Forms::Panel *  drawPanel;
	private: System::Windows::Forms::CheckBox *  antialiasCheck;
	private: System::Windows::Forms::TextBox *  ray_text;
	private: System::Windows::Forms::TextBox *  aa_text;
	private: System::Windows::Forms::Button *  button2;





	private: System::ComponentModel::IContainer *  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = new System::ComponentModel::Container();
			this->openFileDialog1 = new System::Windows::Forms::OpenFileDialog();
			this->saveFileDialog1 = new System::Windows::Forms::SaveFileDialog();
			this->button1 = new System::Windows::Forms::Button();
			this->timer1 = new System::Windows::Forms::Timer(this->components);
			this->resUpDown = new System::Windows::Forms::NumericUpDown();
			this->textureCheck = new System::Windows::Forms::CheckBox();
			this->drawPanel = new System::Windows::Forms::Panel();
			this->antialiasCheck = new System::Windows::Forms::CheckBox();
			this->ray_text = new System::Windows::Forms::TextBox();
			this->aa_text = new System::Windows::Forms::TextBox();
			this->button2 = new System::Windows::Forms::Button();
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->resUpDown))->BeginInit();
			this->SuspendLayout();
			// 
			// openFileDialog1
			// 
			this->openFileDialog1->Filter = S"IV files|*.iv|All files|*.*";
			// 
			// button1
			// 
			this->button1->Location = System::Drawing::Point(8, 8);
			this->button1->Name = S"button1";
			this->button1->TabIndex = 0;
			this->button1->Text = S"Ray Trace";
			this->button1->Click += new System::EventHandler(this, Raytrace);
			// 
			// timer1
			// 
			this->timer1->Interval = 1;
			this->timer1->Tick += new System::EventHandler(this, timer1_Tick);
			// 
			// resUpDown
			// 
			this->resUpDown->Location = System::Drawing::Point(168, 8);
			System::Int32 __mcTemp__1[] = new System::Int32[4];
			__mcTemp__1[0] = 2048;
			__mcTemp__1[1] = 0;
			__mcTemp__1[2] = 0;
			__mcTemp__1[3] = 0;
			this->resUpDown->Maximum = System::Decimal(__mcTemp__1);
			System::Int32 __mcTemp__2[] = new System::Int32[4];
			__mcTemp__2[0] = 32;
			__mcTemp__2[1] = 0;
			__mcTemp__2[2] = 0;
			__mcTemp__2[3] = 0;
			this->resUpDown->Minimum = System::Decimal(__mcTemp__2);
			this->resUpDown->Name = S"resUpDown";
			this->resUpDown->Size = System::Drawing::Size(56, 20);
			this->resUpDown->TabIndex = 2;
			System::Int32 __mcTemp__3[] = new System::Int32[4];
			__mcTemp__3[0] = 512;
			__mcTemp__3[1] = 0;
			__mcTemp__3[2] = 0;
			__mcTemp__3[3] = 0;
			this->resUpDown->Value = System::Decimal(__mcTemp__3);
			// 
			// textureCheck
			// 
			this->textureCheck->Location = System::Drawing::Point(232, 8);
			this->textureCheck->Name = S"textureCheck";
			this->textureCheck->Size = System::Drawing::Size(72, 24);
			this->textureCheck->TabIndex = 3;
			this->textureCheck->Text = S"Textures";
			// 
			// drawPanel
			// 
			this->drawPanel->Anchor = (System::Windows::Forms::AnchorStyles)((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Bottom) 
				| System::Windows::Forms::AnchorStyles::Left);
			this->drawPanel->Location = System::Drawing::Point(8, 40);
			this->drawPanel->Name = S"drawPanel";
			this->drawPanel->Size = System::Drawing::Size(72, 72);
			this->drawPanel->TabIndex = 4;
			this->drawPanel->Paint += new System::Windows::Forms::PaintEventHandler(this, drawPanel_Paint);
			// 
			// antialiasCheck
			// 
			this->antialiasCheck->Checked = true;
			this->antialiasCheck->CheckState = System::Windows::Forms::CheckState::Checked;
			this->antialiasCheck->Location = System::Drawing::Point(304, 8);
			this->antialiasCheck->Name = S"antialiasCheck";
			this->antialiasCheck->Size = System::Drawing::Size(72, 24);
			this->antialiasCheck->TabIndex = 3;
			this->antialiasCheck->Text = S"Anti-Alias";
			// 
			// ray_text
			// 
			this->ray_text->Location = System::Drawing::Point(376, 8);
			this->ray_text->Name = S"ray_text";
			this->ray_text->Size = System::Drawing::Size(72, 20);
			this->ray_text->TabIndex = 5;
			this->ray_text->Text = S"0";
			// 
			// aa_text
			// 
			this->aa_text->Location = System::Drawing::Point(456, 8);
			this->aa_text->Name = S"aa_text";
			this->aa_text->Size = System::Drawing::Size(64, 20);
			this->aa_text->TabIndex = 6;
			this->aa_text->Text = S"0";
			// 
			// button2
			// 
			this->button2->Enabled = false;
			this->button2->Location = System::Drawing::Point(88, 8);
			this->button2->Name = S"button2";
			this->button2->TabIndex = 0;
			this->button2->Text = S"Animate";
			this->button2->Click += new System::EventHandler(this, button2_Click);
			// 
			// Form1
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 13);
			this->BackColor = System::Drawing::SystemColors::Control;
			this->ClientSize = System::Drawing::Size(530, 122);
			this->Controls->Add(this->aa_text);
			this->Controls->Add(this->ray_text);
			this->Controls->Add(this->antialiasCheck);
			this->Controls->Add(this->drawPanel);
			this->Controls->Add(this->textureCheck);
			this->Controls->Add(this->resUpDown);
			this->Controls->Add(this->button1);
			this->Controls->Add(this->button2);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MinimumSize = System::Drawing::Size(512, 80);
			this->Name = S"Form1";
			this->Text = S"WinRay";
			this->Load += new System::EventHandler(this, Form1_Load);
			this->Paint += new System::Windows::Forms::PaintEventHandler(this, Form1_Paint);
			(__try_cast<System::ComponentModel::ISupportInitialize *  >(this->resUpDown))->EndInit();
			this->ResumeLayout(false);

		}	

	private: System::Void Form1_Load(System::Object *  sender, System::EventArgs *  e)
			 {
				 this->ResizeRedraw = true;
			 }

	/*protected: void OnPaintBackground(PaintEventArgs* pevent)
			{
				// Do nothing.
			}*/



	private: System::Void Raytrace(System::Object *  sender, System::EventArgs *  e)
			 {
				 if (openFileDialog1->ShowDialog() == DialogResult::OK) {
					 this->Height = 80 + Decimal::ToInt32(resUpDown->Value);
					 this->Width = 24 + Decimal::ToInt32(resUpDown->Value);
					 drawPanel->Width = Decimal::ToInt32(resUpDown->Value);

					 _scene = new Scene();
					 _camera = new Camera();
					 char *filename = (char*)(void*)Marshal::StringToHGlobalAnsi(openFileDialog1->FileName);
					 raytrace_load(filename, Decimal::ToInt32(resUpDown->Value), _scene, _camera, textureCheck->Checked);
					 _camera->rayTraceSetup(_scene);
					 quick = true;
					 if(frame > 0) {
						 quick = false;
						 SbVec3f eye = _camera->getPosition();
						 y = eye[1];
						 radius = sqrt(eye[0]*eye[0] + eye[2]*eye[2]);
					 }
					 sl = 0;
					 timer1->Enabled = true;
				 }

				 drawPanel->Invalidate();
			 }
	private: System::Void timer1_Tick(System::Object *  sender, System::EventArgs *  e)
			 {
				 sl_last = sl;
				 clock_t endwait;
				 endwait = clock () + .5 * CLK_TCK ;
				 while (clock() < endwait) {
					 _camera->rayTraceScanline(_scene, drawing, sl++, quick, antialiasCheck->Checked);
					 if(sl >= Decimal::ToInt32(resUpDown->Value)) {
						 drawPanel->Invalidate(Rectangle(0, sl_last, Decimal::ToInt32(resUpDown->Value), sl-sl_last));
						 if(quick) {
							 quick = false;
							 sl = 0;
							 _camera->ray_count = 0;
						 }
						 else {
							timer1->Enabled = false;
						 }
						 return;
					 }
				 }
				 ray_text->Text = _camera->ray_count.ToString();
				 aa_text->Text = _camera->aa_count.ToString();
				 drawPanel->Invalidate(Rectangle(0, sl_last, Decimal::ToInt32(resUpDown->Value), sl-sl_last));
			 }

	private: System::Void drawPanel_Paint(System::Object *  sender, System::Windows::Forms::PaintEventArgs *  e)
			{
				e->Graphics->DrawImage(drawing, 0, e->ClipRectangle.get_Y(), e->ClipRectangle, GraphicsUnit::Pixel);
			}

	private: System::Void Form1_Paint(System::Object *  sender, System::Windows::Forms::PaintEventArgs *  e)
			{
				drawPanel->Invalidate();
			}

	private: System::Void button2_Click(System::Object *  sender, System::EventArgs *  e)
			{
				frame = 1;
				Raytrace(sender, e);
			}

};
}


